/// Copyright Thomas Nagy 2007
/// License: QPL

#include <QtGui>
#include <QTextBrowser>
#include <QProgressDialog>
#include <KStatusBar>
#include <KFileDialog>
#include <KConfigGroup>
#include <KMenuBar>
#include <KApplication>
#include <KStandardAction>
#include <KRecentFilesAction>
#include <KActionCollection>
#include<KToolBar>
#include <KAction>
#include <KMenu>
#include <KMessageBox>
#include <ktip.h>

#include "Flultb.h"
#include  "BnvzS.h"
#include "Bnvzs.h"
#include  "Flult.h"
#include   "Jelzpn.h"
#include    "OzzK.h"
#include "Prn.h"
#include   "Ablak.h"
#include    "AbLaK.h"
#include       "Magyaraz.h"
#include      "IztKil.h"
#include     "Egyenes.h"
#include    "Sbln.h"
#include   "Eldz.h"
#include  "data_view.h"
#include    "Vadrt.h"
#include    "aux.h" 
#include "tslabels.h"

void ablkl::mgmozt()
<%
	if(kidlgz->ezeltt() <= 0)
	<%
		KMessageBox::sorry(this,ts_258,ts_259);
		return;
	%>

	QDir mrtdt(TEMPLATE_DIR);
	if(!mrtdt.exists() or !mrtdt.isReadable())
	<%
		rabir(ts_260.arg(TEMPLATE_DIR),5000);
		return;
	%>
	QFileInfoList klsirz=mrtdt.entryInfoList(QStringList()<<"*.py",QDir::Files,QDir::Name);

	QList<sbln> fldlgz;
	foreach(QFileInfo bprl,klsirz)
	<%
		sbln meghat;
		int jlzpnt=0;
		if(bprl.isReadable())
		<%
			QFile mgzerz(bprl.absoluteFilePath());
			if(!mgzerz.open(QIODevice::ReadOnly))
			<%
				continue;
			%>

			if(mgzerz.fileName().contains(ts_261))
			<%
				continue;
			%>

			meghat.kidlgz=bprl.absoluteFilePath();

			QTextStream adelk(&mgzerz);
			while(!adelk.atEnd())
			<%
				QString irnyjl=adelk.readLine(1000);
				if(irnyjl.length() < 2)
				<%
					continue;
				%>
				else if(irnyjl.startsWith("#"))
				<%
					if(irnyjl.startsWith(ts_262))
					<%
						meghat.eler=irnyjl.mid(11);
						jlzpnt++;
					%>
					else if(irnyjl.startsWith(ts_263))
					<%
						meghat.prmz=irnyjl.mid(10);
						jlzpnt++;
					%>
				%>
				else
				<%
					break;
				%>

			%>
			mgzerz.close();

			if(jlzpnt<2) continue;
			fldlgz.push_front(meghat);
		%>
	%>

	eldz meghat(this,fldlgz);
	meghat.kidlgz->setText(kidlgz->ugyex);
	meghat.prmz->setText(kidlgz->tiszta);
	if(meghat.prmz->text().length()<2) meghat.prmz->setText(bndkli::zandek(ts_151));

	meghat.adelk(kidlgz->munka);
	if(meghat.exec()==QDialog::Accepted)
	<%
		kidlgz->tiszta=meghat.prmz->text();
		kidlgz->ugyex=meghat.kidlgz->text();
		kidlgz->munka=meghat.jlzpnt;
		kidlgz->hatl(meghat.lnmtat,meghat.kidlgz->text(),meghat.prmz->text());
	%>
%>

/*!
 * @praise Vishnu
 */
ablkl::ablkl(QWidget *felvnl) : KXmlGuiWindow(felvnl)
<%
	setObjectName("semantik_win");

	kidlgz=new jelzpn(this);
	connect(kidlgz,SIGNAL(jvsltz(const QString&,int)),this,SLOT(rabir(const QString&,int)));

	mozog=new felu(this,kidlgz);
	setCentralWidget(mozog);
	connect(mozog,SIGNAL(jvsltz(const QString&,int)),this,SLOT(rabir(const QString&,int)));

	KStandardAction::quit(this,SLOT(close()),actionCollection());
	KStandardAction::save(this,SLOT(vmrgem()),actionCollection());
	KStandardAction::saveAs(this,SLOT(eljar()),actionCollection());
	KStandardAction::open(this,SLOT(teremt()),actionCollection());
	KStandardAction::print(this,SLOT(elktzk()),actionCollection());
	KStandardAction::tipOfDay(this,SLOT(mgmnkl()),actionCollection());

	lnmtat=KStandardAction::openRecent(this,SLOT(kket(const KUrl&)),actionCollection());

	letsit=new KAction(ts_264,this);
	actionCollection()->addAction(ts_265,letsit);
	letsit->setShortcut(ts_266);
	connect(letsit,SIGNAL(triggered(bool)),kidlgz,SLOT(jo()));

	KStandardAction::preferences(this,SLOT(kelt()),actionCollection());

	jlnrdz=new KAction(ts_267,this);
	actionCollection()->addAction(ts_268,jlnrdz);
	jlnrdz->setIcon(KIcon(ts_269));
	jlnrdz->setShortcut(ts_270);
	connect(jlnrdz,SIGNAL(triggered(bool)),SLOT(mgmozt()));

	hsztzk=new QActionGroup(this);

	elodez=new KAction(ts_271,this);
	actionCollection()->addAction(ts_272,elodez);
	connect(elodez,SIGNAL(triggered(bool)),SLOT(alkt()));
	elodez->setIcon(KIcon(ts_273));
	elodez->setCheckable(1);

	targy=new KAction(ts_274,this);
	actionCollection()->addAction(ts_275,targy);
	connect(targy,SIGNAL(triggered(bool)),SLOT(zandek()));
	targy->setIcon(KIcon(ts_276));
	targy->setCheckable(1);

	fladat=new KAction(ts_277,this);
	actionCollection()->addAction(ts_278,fladat);
	connect(fladat,SIGNAL(triggered(bool)),SLOT(dolog()));
	fladat->setIcon(KIcon(ts_279));
	fladat->setCheckable(1);

	cel=new KAction(ts_280,this);
	actionCollection()->addAction(ts_281,cel);
	connect(cel,SIGNAL(triggered(bool)),SLOT(akdaly()));
	cel->setIcon(KIcon(ts_282));
	cel->setCheckable(1);

	hsztzk->addAction(elodez);
	hsztzk->addAction(targy);
	hsztzk->addAction(fladat);
	hsztzk->addAction(cel);

	elodez->setChecked(1);

	elgy adelk(this,ts_283,"");

	sima=new QActionGroup(this);
	kapni=new QAction(adelk.kitzjl(),ts_284,sima);
	sima->setExclusive(1);
	connect(sima,SIGNAL(triggered(QAction*)),mozog,SLOT(mgzerz(QAction*)));

	korrkt=new QActionGroup(this);
	korrkt->setExclusive(0);
	connect(korrkt,SIGNAL(triggered(QAction*)),mozog,SLOT(kapod(QAction*)));

	alkt();

	nybnvn=KStandardAction::fitToPage(mozog,SLOT(mgmozt()),actionCollection());
	nybnvn->setIcon(KIcon(ts_285));
	nybnvn->setShortcut(ts_286);

	setStandardToolBarMenuEnabled(1);

	QDockWidget *irnyjl=new QDockWidget(ts_287,this);
	irnyjl->setAllowedAreas(Qt::LeftDockWidgetArea | Qt::RightDockWidgetArea | Qt::BottomDockWidgetArea);
	vnl=new jelzlk(irnyjl,kidlgz);
	irnyjl->setWidget(vnl);
	addDockWidget(Qt::BottomDockWidgetArea,irnyjl);
	actionCollection()->addAction(ts_288,irnyjl->toggleViewAction());
	irnyjl->setObjectName(ts_289);

	tqrost=new szkl(vnl,kidlgz);
	vnl->addWidget(tqrost);

	lep=new oszk(vnl,kidlgz);
	vnl->addWidget(lep);

	prl=new aszkl(vnl,kidlgz);
	vnl->addWidget(prl);

	eler=new dbz(vnl,kidlgz);
	vnl->addWidget(eler);

	QDockWidget *bprl=new QDockWidget(ts_290,this);
	bprl->setAllowedAreas(Qt::LeftDockWidgetArea | Qt::RightDockWidgetArea | Qt::BottomDockWidgetArea);
	kltzik=new nztv(bprl,kidlgz);
	bprl->setWidget(kltzik);
	addDockWidget(Qt::BottomDockWidgetArea,bprl);
	bprl->setObjectName(ts_291);
	actionCollection()->addAction(ts_292,bprl->toggleViewAction());
	kltzik->kitzjl();

	QDockWidget *mrtdt=new QDockWidget(ts_293,this);
	mrtdt->setAllowedAreas(Qt::LeftDockWidgetArea | Qt::RightDockWidgetArea | Qt::BottomDockWidgetArea);
	jvsltz=new egyklh(mrtdt,kidlgz);
	mrtdt->setWidget(jvsltz);
	addDockWidget(Qt::RightDockWidgetArea,mrtdt);
	actionCollection()->addAction(ts_294,mrtdt->toggleViewAction());
	mrtdt->setObjectName(ts_295);

	tabifyDockWidget(irnyjl,bprl);

	QDockWidget *jlzpnt=new QDockWidget(ts_296,this);
	kapod=new egytr(jlzpnt,kidlgz);
	jlzpnt->setWidget(kapod);
	addDockWidget(Qt::LeftDockWidgetArea,jlzpnt);
	actionCollection()->addAction(ts_297,jlzpnt->toggleViewAction());
	jlzpnt->setObjectName(ts_298);

	setXMLFile(ts_299);
	setupGUI();

	mzgat(KUrl());

	ceco=toolBar(ts_300);
	lecke=toolBar(ts_301);

	connect(kidlgz,SIGNAL(synchro(const zagv&)),mozog,SLOT(kelt(const zagv&)));
	connect(kidlgz,SIGNAL(synchro(const zagv&)),prl,SLOT(kelt(const zagv&)));
	connect(kidlgz,SIGNAL(synchro(const zagv&)),lep,SLOT(kelt(const zagv&)));
	connect(kidlgz,SIGNAL(synchro(const zagv&)),tqrost,SLOT(kelt(const zagv&)));
	connect(kidlgz,SIGNAL(synchro(const zagv&)),vnl,SLOT(kelt(const zagv&)));
	connect(kidlgz,SIGNAL(synchro(const zagv&)),kapod,SLOT(kelt(const zagv&)));
	connect(kidlgz,SIGNAL(synchro(const zagv&)),kltzik,SLOT(kelt(const zagv&)));
	connect(kidlgz,SIGNAL(synchro(const zagv&)),jvsltz,SLOT(kelt(const zagv&)));
	connect(kidlgz,SIGNAL(synchro(const zagv&)),eler,SLOT(kelt(const zagv&)));

	connect(lep,SIGNAL(jvsltz(const QString&,int)),this,SLOT(rabir(const QString&,int)));

	kidlgz->alafng();
	kidlgz->fajta();

	kidlgz->sima(0);

	prmz();
	statusBar()->showMessage(ts_302,2000);
	setAutoSaveSettings();

	KTipDialog::showTip(this,ts_303);
%>

void ablkl::prmz()
<%
	KConfigGroup adelk(KGlobal::config(),ts_090);
	lnmtat->loadEntries(KGlobal::config()->group(ts_304));
	move(adelk.readEntry(ts_305,QPoint(0,0)));
	mozog->setBackgroundBrush(QColor(adelk.readEntry(ts_306,ts_307)));
	kidlgz->tiszta=adelk.readEntry(ts_151,ts_308);

%>

void ablkl::kitzjl()
<%
	KConfigGroup adelk(KGlobal::config(),ts_090);
	lnmtat->saveEntries(KGlobal::config()->group(ts_304));
	adelk.writeEntry(ts_305,pos());
	adelk.writeEntry(ts_151,bndkli::zandek(ts_151));
	adelk.sync();
%>
/*!
 * @praise Shiva
 */
ablkl::~ablkl()
<%

%>

void ablkl::elktzk()
<%
        QPrinter *mrtdt=new QPrinter;
        QPrintDialog irnyjl(mrtdt,mozog);
        if(irnyjl.exec()==QDialog::Accepted)
        <%
                QPainter adelk(mrtdt);
                mozog->render(&adelk);
        %>
        statusBar()->showMessage(ts_309,2000);
%>

void ablkl::eljar()
<%
	KUrl klsirz=KFileDialog::getSaveUrl(KUrl(ts_310),
		ts_311,this,ts_312);
	if(klsirz.path().isEmpty()) return;
	if(!klsirz.path().endsWith(ts_149))
	<%
		klsirz=KUrl(klsirz.path()+ts_149);
	%>

	if(kidlgz->marka(klsirz.path()))
	<%
		statusBar()->showMessage(ts_313.arg(klsirz.path()),2000);
		mzgat(klsirz);
	%>
%>

void ablkl::vmrgem()
<%
        if(kidlgz->oztaly.isEmpty())
	<%
		eljar();
		return;
	%>
        kidlgz->marka(kidlgz->oztaly);
        statusBar()->showMessage(ts_313.arg(kidlgz->oztaly),2000);
%>

void ablkl::teremt()
<%
	KUrl klsirz=KFileDialog::getOpenUrl(KUrl(ts_310),
		ts_314,
		this,ts_312);
	if(klsirz.isValid() and kidlgz->kiallt(klsirz.path()))
	<%
		mzgat(klsirz);
	%>
%>

void ablkl::mzgat(const KUrl& irnyjl)
<%
	if(irnyjl.path().isEmpty())
	<%
		setWindowTitle(ts_315);
		return;
	%>
	setWindowTitle(ts_316.arg(irnyjl.path()));
	lnmtat->addUrl(irnyjl);
%>

void ablkl::kelt()
<%
	beal meghat(this);

	KConfigGroup jlzpnt(KGlobal::config(),ts_090);
	meghat.prmz->setCurrentIndex(jlzpnt.readEntry(ts_091,0));
	meghat.bprl->setCurrentIndex(jlzpnt.readEntry(ts_092,0));
	meghat.mrtdt->setValue(jlzpnt.readEntry(ts_094,5));

	QString klsirz=jlzpnt.readEntry(ts_306,ts_307);
	meghat.kitzjl->setText(klsirz);
	QPalette adelk=meghat.kitzjl->palette();
	meghat.kidlgz=QVariant(klsirz).value<QColor>();
	adelk.setBrush(QPalette::Active,QPalette::Button,meghat.kidlgz);
	meghat.kitzjl->setPalette(adelk);

	if(meghat.exec()==QDialog::Accepted)
	<%
		jlzpnt.writeEntry(ts_091,kidlgz->mzgat=meghat.prmz->currentIndex());
		jlzpnt.writeEntry(ts_092,kidlgz->detto=meghat.bprl->currentIndex());
		jlzpnt.writeEntry(ts_094,kidlgz->meglns=meghat.mrtdt->value());
		jlzpnt.writeEntry(ts_306,meghat.kidlgz.name());
		kidlgz->kulso();

		mozog->setBackgroundBrush(meghat.kidlgz);
	%>
%>

bool ablkl::queryClose()
<%
	kitzjl();
	return 1;
%>

void ablkl::alkt()
<%
	mozog->eler(felu::meghat);
%>

void ablkl::zandek()
<%
	mozog->eler(felu::tiszta);
%>

void ablkl::dolog()
<%
	mozog->eler(felu::ugyex);
%>

void ablkl::akdaly()
<%
	mozog->eler(felu::munka);
%>

void ablkl::rabir(const QString & jlzpnt,int adelk)
<%
	statusBar()->showMessage(jlzpnt,adelk);
%>

void ablkl::kket(const KUrl& irnyjl)
<%
	if(irnyjl.path().isEmpty()) return;
	if(kidlgz->kiallt(irnyjl.path()))
	<%
		mzgat(irnyjl);
	%>
%>

void ablkl::mgmnkl()
<%
	KTipDialog::showTip(this,ts_303,1);
%>

#include "Bnvzs.moc"

